searchNodes=[{"doc":"NearestDate is a micro library to help finding the date with the smallest delta to a given date.","ref":"NearestDate.html","title":"NearestDate","type":"module"},{"doc":"Returns the datetime from the given list with the smallest delta to the given target datetime. Options :direction - (:future, :past) constrains the search space in one direction. Defaults to nil which will search both future and past. Examples iex&gt; list_of_dates = [ &quot;2019-12-31T01:00:00+02:00&quot; , &quot;2020-03-01T02:00:00+02:00&quot; ] iex&gt; NearestDate . find ( list_of_dates , &quot;2020-01-01T00:00:00+02:00&quot; ) { :ok , &quot;2019-12-31T01:00:00+02:00&quot; } iex&gt; list_of_dates = [ &quot;2020-02-01T01:00:00+02:00&quot; , &quot;2020-03-01T02:00:00+02:00&quot; ] iex&gt; NearestDate . find ( list_of_dates , &quot;2020-01-01T00:00:00+02:00&quot; , direction : :future ) { :ok , &quot;2020-02-01T01:00:00+02:00&quot; } iex&gt; list_of_dates = [ &quot;2019-02-01T01:00:00+02:00&quot; , &quot;2018-03-01T02:00:00+02:00&quot; ] iex&gt; NearestDate . find ( list_of_dates , &quot;2020-01-01T00:00:00+02:00&quot; , direction : :future ) { :error , % NearestDate.Error { reason : :not_found } } iex&gt; list_of_dates = [ &quot;2019-02-01T01:00:00+02:00&quot; , &quot;2016-03-01T02:00:00+02:00&quot; ] iex&gt; NearestDate . find ( list_of_dates , &quot;2020-01-01T00:00:00+02:00&quot; , direction : :past ) { :ok , &quot;2019-02-01T01:00:00+02:00&quot; }","ref":"NearestDate.html#find/3","title":"NearestDate.find/3","type":"function"},{"doc":"","ref":"NearestDate.html#find!/3","title":"NearestDate.find!/3","type":"function"},{"doc":"","ref":"NearestDate.html#t:direction/0","title":"NearestDate.direction/0","type":"type"},{"doc":"Exception that represents an error in datetime terms. This exception has a :reason field that can have one of the following values: :not_found - means that no datetime was found which meets the critea defined in the options. {:invalid_date, term} - means that the given term is not a valid datetime format.","ref":"NearestDate.Error.html","title":"NearestDate.Error","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"NearestDate.Error.html#message/1","title":"NearestDate.Error.message/1","type":"function"},{"doc":"","ref":"NearestDate.Error.html#t:t/0","title":"NearestDate.Error.t/0","type":"type"},{"doc":"NearestDate NearestDate is a micro library to help finding the date with the smallest delta to a given date. iex(1)&gt; dates = [ ...(1)&gt; &quot;1954-12-03 05:57:03.555380Z&quot; , ... ( 1 ) &gt; &quot;1966-08-12 18:31:33.555380Z&quot; , ... ( 1 ) &gt; &quot;2090-04-12 02:08:51.555380Z&quot; , ... ( 1 ) &gt; &quot;2116-09-02 04:21:16.555380Z&quot; , ... ( 1 ) &gt; &quot;2115-11-08 11:48:11.555380Z&quot; ...(1)&gt; ] iex(2)&gt; NearestDate . find! ( dates , &quot;2021-04-16 16:02:51.555380Z&quot; ) &quot;2090-04-12 02:08:51.555380Z&quot;","ref":"readme.html","title":"NearestDate","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding nearest_date to your list of dependencies in mix.exs : def deps do [ { :nearest_date , &quot;~&gt; 0.2.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/nearest_date .","ref":"readme.html#installation","title":"NearestDate - Installation","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Breaking changes: Converted all error reasons to proper exceptions: non-raising functions now return {:error, NearestDate.Error.t} in case of failure instead of {:error, term} . The order of arguments for both find!/3 and find/3 has been adjusted to make a more &quot;pipe friendly&quot; api. find/3 returns {:ok, result} | {:error, exception} instead of just returning the result or raising an exception. find!/3 returns the pure result or raises an exception in line with Elixir conventions. Options :future and :past have been replaced by a single option: :direction which defaults to nil . When set to either :future or :past will constrain the search to the given direction.","ref":"changelog.html#v0-2-0-2021-05-07","title":"Changelog - v0.2.0 (2021-05-07)","type":"extras"},{"doc":"Additional exception handling - invalid dates in the list are ignored and invalid target will raise ArgumentError","ref":"changelog.html#v0-1-1-2021-04-28","title":"Changelog - v0.1.1 (2021-04-28)","type":"extras"},{"doc":"Initial commit - basic functionality implemented fastest approach after extensive benchmarking","ref":"changelog.html#v0-1-0-2021-04-16","title":"Changelog - v0.1.0 (2021-04-16)","type":"extras"},{"doc":"Copyright (c) 2021-present Keith Salisbury Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]